<template>
<form>
  <div class="form-group">
    <FormInput
      label="Name"
      name="name"
      :value="form.name"
      @onInputChange="handleInputUpdate"
    />
  </div>
  <div class="form-group">
    <FormInput
      label="Source language"
      :value="form.sourceLanguage"
      name="sourceLanguage"
      @onInputChange="handleInputUpdate"
    />
  </div>
  <div class="form-group">
    <label for="targetLanguages">Target languages</label>
    <select
      multiple
      v-model="form.targetLanguages"
      class="form-control"
      id="targetLanguages"
    >
      <option
        v-for="option in availableLanguages"
        :key="`available-language-${option}`"
        v-bind:value="option"
      >
        {{option}}
      </option>
    </select>
  </div>
  <div class="form-group">
    <a class="btn btn-success" @click="submitForm">
      {{submitButtonText}}

    </a>
  </div>
</form>
</template>
<script lang="ts">
import Vue from 'vue';
import { Component, Prop } from 'vue-property-decorator';
import { InputResults, ProjectForm as ProjectFormType } from '@/types';
import { FormInput, FormSelect } from '@/components/atoms';
import axios from 'axios';

@Component({
  components: { FormInput, FormSelect },
})
export default class ProjectForm extends Vue {
  @Prop({ default: null }) project!: ProjectFormType | null

  private form: ProjectFormType = {
    name: '',
    sourceLanguage: '',
    targetLanguages: [],
    status: '',
    dateCreated: '',
    dateUpdated: '',
    dateDue: '',
  }

  private availableLanguages: Array<string> = [
    'cs', 'de', 'fi', 'en',
  ]

  get submitButtonText(): string {
    return this.project ? 'save' : 'create';
  }

  handleInputUpdate(inputResults: InputResults): void {
    const { key, value } = inputResults;
    this.form[key] = value;
  }

  created() {
    if (this.project) {
      this.form = { ...this.project };
    }
  }

  async createProject(): Promise<boolean> {
    const now = new Date().toISOString();
    this.form = {
      ...this.form,
      status: 'NEW',
      dateCreated: now,
      dateUpdated: now,
      dateDue: now,
    };
    const { status } = await axios.post('/projects', this.form);
    return status >= 300;
  }

  async updateProject(): Promise<boolean> {
    const now = new Date();
    this.form = {
      ...this.form,
      dateUpdated: now.toISOString(),
    };
    const { status } = await axios.put(`/projects/${this.$route.params.id}`, this.form);
    return status >= 300;
  }

  async submitForm() {
    let hasErrors = false;
    if (this.project) {
      hasErrors = await this.updateProject();
    } else {
      hasErrors = await this.createProject();
    }

    if (!hasErrors) {
      this.$router.push({ name: 'projects-success' });
    }
  }
}
</script>
